# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageK8SZoneContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'clusters': 'list[Cmxapiresourcesk8szonesClusters]',
        'created_millis': 'int',
        'custom_properties': 'dict(str, object)',
        'description': 'str',
        'id': 'str',
        'name': 'str',
        'org_id': 'str',
        'projects': 'list[Cmxapiresourcesk8szonesProjects]',
        'provider_id': 'str',
        'provider_type': 'str',
        'resources': 'list[Cmxapiresourcesk8szonesResources]',
        'supervisor_clusters': 'list[Cmxapiresourcesk8szonesSupervisorClusters]',
        'supervisor_namespaces': 'list[Cmxapiresourcesk8szonesSupervisorNamespaces]',
        'tag_ids': 'list[str]',
        'tag_links': 'list[str]',
        'tags': 'list[Cmxapiresourcesk8szonesTags]',
        'updated_millis': 'int'
    }

    attribute_map = {
        'clusters': 'clusters',
        'created_millis': 'createdMillis',
        'custom_properties': 'customProperties',
        'description': 'description',
        'id': 'id',
        'name': 'name',
        'org_id': 'orgId',
        'projects': 'projects',
        'provider_id': 'providerId',
        'provider_type': 'providerType',
        'resources': 'resources',
        'supervisor_clusters': 'supervisorClusters',
        'supervisor_namespaces': 'supervisorNamespaces',
        'tag_ids': 'tagIds',
        'tag_links': 'tagLinks',
        'tags': 'tags',
        'updated_millis': 'updatedMillis'
    }

    def __init__(self, clusters=None, created_millis=None, custom_properties=None, description=None, id=None, name=None, org_id=None, projects=None, provider_id=None, provider_type=None, resources=None, supervisor_clusters=None, supervisor_namespaces=None, tag_ids=None, tag_links=None, tags=None, updated_millis=None):  # noqa: E501
        """PageK8SZoneContent - a model defined in Swagger"""  # noqa: E501
        self._clusters = None
        self._created_millis = None
        self._custom_properties = None
        self._description = None
        self._id = None
        self._name = None
        self._org_id = None
        self._projects = None
        self._provider_id = None
        self._provider_type = None
        self._resources = None
        self._supervisor_clusters = None
        self._supervisor_namespaces = None
        self._tag_ids = None
        self._tag_links = None
        self._tags = None
        self._updated_millis = None
        self.discriminator = None
        if clusters is not None:
            self.clusters = clusters
        if created_millis is not None:
            self.created_millis = created_millis
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if description is not None:
            self.description = description
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if org_id is not None:
            self.org_id = org_id
        if projects is not None:
            self.projects = projects
        if provider_id is not None:
            self.provider_id = provider_id
        if provider_type is not None:
            self.provider_type = provider_type
        if resources is not None:
            self.resources = resources
        if supervisor_clusters is not None:
            self.supervisor_clusters = supervisor_clusters
        if supervisor_namespaces is not None:
            self.supervisor_namespaces = supervisor_namespaces
        if tag_ids is not None:
            self.tag_ids = tag_ids
        if tag_links is not None:
            self.tag_links = tag_links
        if tags is not None:
            self.tags = tags
        if updated_millis is not None:
            self.updated_millis = updated_millis

    @property
    def clusters(self):
        """Gets the clusters of this PageK8SZoneContent.  # noqa: E501


        :return: The clusters of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8szonesClusters]
        """
        return self._clusters

    @clusters.setter
    def clusters(self, clusters):
        """Sets the clusters of this PageK8SZoneContent.


        :param clusters: The clusters of this PageK8SZoneContent.  # noqa: E501
        :type: list[Cmxapiresourcesk8szonesClusters]
        """

        self._clusters = clusters

    @property
    def created_millis(self):
        """Gets the created_millis of this PageK8SZoneContent.  # noqa: E501


        :return: The created_millis of this PageK8SZoneContent.  # noqa: E501
        :rtype: int
        """
        return self._created_millis

    @created_millis.setter
    def created_millis(self, created_millis):
        """Sets the created_millis of this PageK8SZoneContent.


        :param created_millis: The created_millis of this PageK8SZoneContent.  # noqa: E501
        :type: int
        """

        self._created_millis = created_millis

    @property
    def custom_properties(self):
        """Gets the custom_properties of this PageK8SZoneContent.  # noqa: E501


        :return: The custom_properties of this PageK8SZoneContent.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this PageK8SZoneContent.


        :param custom_properties: The custom_properties of this PageK8SZoneContent.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_properties = custom_properties

    @property
    def description(self):
        """Gets the description of this PageK8SZoneContent.  # noqa: E501


        :return: The description of this PageK8SZoneContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PageK8SZoneContent.


        :param description: The description of this PageK8SZoneContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this PageK8SZoneContent.  # noqa: E501


        :return: The id of this PageK8SZoneContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageK8SZoneContent.


        :param id: The id of this PageK8SZoneContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this PageK8SZoneContent.  # noqa: E501


        :return: The name of this PageK8SZoneContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageK8SZoneContent.


        :param name: The name of this PageK8SZoneContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def org_id(self):
        """Gets the org_id of this PageK8SZoneContent.  # noqa: E501


        :return: The org_id of this PageK8SZoneContent.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this PageK8SZoneContent.


        :param org_id: The org_id of this PageK8SZoneContent.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def projects(self):
        """Gets the projects of this PageK8SZoneContent.  # noqa: E501


        :return: The projects of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8szonesProjects]
        """
        return self._projects

    @projects.setter
    def projects(self, projects):
        """Sets the projects of this PageK8SZoneContent.


        :param projects: The projects of this PageK8SZoneContent.  # noqa: E501
        :type: list[Cmxapiresourcesk8szonesProjects]
        """

        self._projects = projects

    @property
    def provider_id(self):
        """Gets the provider_id of this PageK8SZoneContent.  # noqa: E501


        :return: The provider_id of this PageK8SZoneContent.  # noqa: E501
        :rtype: str
        """
        return self._provider_id

    @provider_id.setter
    def provider_id(self, provider_id):
        """Sets the provider_id of this PageK8SZoneContent.


        :param provider_id: The provider_id of this PageK8SZoneContent.  # noqa: E501
        :type: str
        """

        self._provider_id = provider_id

    @property
    def provider_type(self):
        """Gets the provider_type of this PageK8SZoneContent.  # noqa: E501


        :return: The provider_type of this PageK8SZoneContent.  # noqa: E501
        :rtype: str
        """
        return self._provider_type

    @provider_type.setter
    def provider_type(self, provider_type):
        """Sets the provider_type of this PageK8SZoneContent.


        :param provider_type: The provider_type of this PageK8SZoneContent.  # noqa: E501
        :type: str
        """
        allowed_values = ["PKS_ENDPOINT", "EXTERNAL", "OPEN_SHIFT", "VSPHERE_NAMESPACES"]  # noqa: E501
        if provider_type not in allowed_values:
            raise ValueError(
                "Invalid value for `provider_type` ({0}), must be one of {1}"  # noqa: E501
                .format(provider_type, allowed_values)
            )

        self._provider_type = provider_type

    @property
    def resources(self):
        """Gets the resources of this PageK8SZoneContent.  # noqa: E501


        :return: The resources of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8szonesResources]
        """
        return self._resources

    @resources.setter
    def resources(self, resources):
        """Sets the resources of this PageK8SZoneContent.


        :param resources: The resources of this PageK8SZoneContent.  # noqa: E501
        :type: list[Cmxapiresourcesk8szonesResources]
        """

        self._resources = resources

    @property
    def supervisor_clusters(self):
        """Gets the supervisor_clusters of this PageK8SZoneContent.  # noqa: E501


        :return: The supervisor_clusters of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8szonesSupervisorClusters]
        """
        return self._supervisor_clusters

    @supervisor_clusters.setter
    def supervisor_clusters(self, supervisor_clusters):
        """Sets the supervisor_clusters of this PageK8SZoneContent.


        :param supervisor_clusters: The supervisor_clusters of this PageK8SZoneContent.  # noqa: E501
        :type: list[Cmxapiresourcesk8szonesSupervisorClusters]
        """

        self._supervisor_clusters = supervisor_clusters

    @property
    def supervisor_namespaces(self):
        """Gets the supervisor_namespaces of this PageK8SZoneContent.  # noqa: E501


        :return: The supervisor_namespaces of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8szonesSupervisorNamespaces]
        """
        return self._supervisor_namespaces

    @supervisor_namespaces.setter
    def supervisor_namespaces(self, supervisor_namespaces):
        """Sets the supervisor_namespaces of this PageK8SZoneContent.


        :param supervisor_namespaces: The supervisor_namespaces of this PageK8SZoneContent.  # noqa: E501
        :type: list[Cmxapiresourcesk8szonesSupervisorNamespaces]
        """

        self._supervisor_namespaces = supervisor_namespaces

    @property
    def tag_ids(self):
        """Gets the tag_ids of this PageK8SZoneContent.  # noqa: E501


        :return: The tag_ids of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[str]
        """
        return self._tag_ids

    @tag_ids.setter
    def tag_ids(self, tag_ids):
        """Sets the tag_ids of this PageK8SZoneContent.


        :param tag_ids: The tag_ids of this PageK8SZoneContent.  # noqa: E501
        :type: list[str]
        """

        self._tag_ids = tag_ids

    @property
    def tag_links(self):
        """Gets the tag_links of this PageK8SZoneContent.  # noqa: E501


        :return: The tag_links of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[str]
        """
        return self._tag_links

    @tag_links.setter
    def tag_links(self, tag_links):
        """Sets the tag_links of this PageK8SZoneContent.


        :param tag_links: The tag_links of this PageK8SZoneContent.  # noqa: E501
        :type: list[str]
        """

        self._tag_links = tag_links

    @property
    def tags(self):
        """Gets the tags of this PageK8SZoneContent.  # noqa: E501


        :return: The tags of this PageK8SZoneContent.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8szonesTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this PageK8SZoneContent.


        :param tags: The tags of this PageK8SZoneContent.  # noqa: E501
        :type: list[Cmxapiresourcesk8szonesTags]
        """

        self._tags = tags

    @property
    def updated_millis(self):
        """Gets the updated_millis of this PageK8SZoneContent.  # noqa: E501


        :return: The updated_millis of this PageK8SZoneContent.  # noqa: E501
        :rtype: int
        """
        return self._updated_millis

    @updated_millis.setter
    def updated_millis(self, updated_millis):
        """Sets the updated_millis of this PageK8SZoneContent.


        :param updated_millis: The updated_millis of this PageK8SZoneContent.  # noqa: E501
        :type: int
        """

        self._updated_millis = updated_millis

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageK8SZoneContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageK8SZoneContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
